function RepositoryFactory(SQLStorageStrategy, localStorageEngine, requestDataSourceEngine, templateManager, dataSourceHolder, ZhLogger, eventEngine,
	IndexedDBEngine, Query, memoryStorageEngine) {

	var RepoType = {
		SQL: SQLStorageStrategy,
		LOCAL: localStorageEngine,
		ONLINE: requestDataSourceEngine,
		INDEXEDDB: IndexedDBEngine,
		MEMORY: memoryStorageEngine
	};

	var instanceNames = [];

	this.factory = function(dataSourceName, type, retryCount, timeout) {
		if (instanceNames.indexOf(dataSourceName) !== -1) {
			ZhLogger.error("Repository for " + dataSourceName + " already defined, please review your source.");
		} else {
			instanceNames.push(dataSourceName);
		}
		return new Repository(dataSourceName, RepoType[type], templateManager, dataSourceHolder, eventEngine, retryCount, timeout, Query);
	};
}