ZeedhiInterations.directive('zhSwipeTip', function($timeout, ScreenService, eventEngine, templateManager) {
	return {
		priority: 1,
		link: function($scope, element, attrs) {
			var scrollControl = attrs.zhSwipeTip ? element.siblings('.'+attrs.zhSwipeTip).eq(0) : element;

			if (!$scope.widget.afterMoveRow) {
				eventEngine.createEvent($scope.widget, 'afterMoveRow');
			}
			var swipeLevel = ScreenService.getSwipeLevel($scope.widget);

			var updateSwipeTip = Util.buildDebounceMethod(function (currentRow) {
				$timeout(function() {
					var currentRowElement = element.find(".currentRow");
					if ((currentRowElement.parents('.zh-grid-container').length > 0 || currentRowElement.parents('.zh-list-container').length) > 0 && !Util.isEmptyObject(currentRow) && ScreenService.isSwipeOpen(swipeLevel+1)) {
						tipScroll(currentRowElement, false);
					} else {
						hideTip();
					}
					ScreenService.updateTemplate();
				}, 100);
			}, 80);

			$scope.$watch('widget.currentRow', updateSwipeTip);
			$scope.widget.afterMoveRow(updateSwipeTip);
			$scope.widget.updateSwipeTip = updateSwipeTip;

			var tipScroll = function(currentRowElement, scrolling) {
				var parentSwipe = currentRowElement.parents('[data-swipe-level]');
				var parentSwipeLevel = 1;
				if (parentSwipe.length > 0) {
					parentSwipeLevel = parseInt(parentSwipe.eq(0).attr('data-swipe-level')) + 1;
				}
				var activeSwipe = $('.zh-swipe-inner[data-swipe-level="'+parentSwipeLevel+'"]');
				if (activeSwipe.length === 0) {
					currentRowElement.addClass('swipe-tip');
				} else {
					var tip = activeSwipe.find('.swipe-tip');
					var parent = currentRowElement.parents('.body').last();
					if (!parent.length) {
						//List template uses the element with zh-list-container class instead of body class
						parent = currentRowElement.parents('.zh-list-container');
					}
					var parentOffsetTop = parent.offset().top;
					var rowOffsetTop = currentRowElement.offset().top;
					var offsetBotton = ($(document).height() - (rowOffsetTop - 35));
					var leftOverUp = rowOffsetTop - parentOffsetTop + 35;
					var lefOoverDown = (offsetBotton - 42) % 35;
					if (lefOoverDown <= 35 && offsetBotton - 42 <= 35 && !scrolling){
						parent.scrollTop(parent.scrollTop() + (35 - lefOoverDown));
					} else if ((rowOffsetTop < parentOffsetTop) && leftOverUp <= 35  && !scrolling) {
						parent.scrollTop(parent.scrollTop() - (35 - leftOverUp));
					} else if (scrolling) {
						activeSwipe.removeClass('.swipe-tip');
					}
					var top = rowOffsetTop - activeSwipe.offset().top;
					tip.css('top', top);
					tip.css('display', top < (parentOffsetTop - activeSwipe.offset().top - 20) ? 'none' : 'block');
				}
			};

			var hideTip = function() {
				var parentSwipe = element.parents('[data-swipe-level]');
				var parentSwipeLevel = 1;
				if (parentSwipe.length > 0) {
					parentSwipeLevel = parseInt(parentSwipe.eq(0).attr('data-swipe-level')) + 1;
				}
				var activeSwipe = $('.zh-swipe-inner[data-swipe-level="'+parentSwipeLevel+'"]');
				if (activeSwipe.length !== 0) {
					var tip = activeSwipe.find('.swipe-tip');
					tip.css('top', -40);
				}
			};

			var onElementScroll = Util.buildDebounceMethod(function() {
				if (ScreenService.isSwipeOpen(swipeLevel+1)) {
					var currentRow = element.find('.currentRow');
					if (currentRow.length) {
						tipScroll(currentRow, true);
					} else {
						hideTip();
					}
				}
			}, 100);

			scrollControl.bind('scroll', onElementScroll);
		}
	};
});